
/*
 *	H
 *	
 *	Copyright 2016 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

#ifndef _LLDISPLAY_CONFIGURATION
#define _LLDISPLAY_CONFIGURATION

/*
 * MicroEJ platform and BSP are ready to configure the LCD number of bits per pixel. Four values
 * are available: 1, 2, 4 and 16.
 *
 * Follow the next steps to configure the number of bits per pixel
 *
 * 1- Specify right MicroEJ display stack
 * 		- Edit "STM32F412GDISCO-Full-CM4_ARMCC-FreeRTOS-configuration/display/display.properties"
 * 		- Set
 * 			"bpp=rgb565" for 16 bits per pixel
 * 			"bpp=c4" for 4 bits per pixel
 * 			"bpp=c2" for 2 bits per pixel
 * 			"bpp=c1" for 1 bit per pixel
 *
 * 2- Build again the MicroEJ Platform Reference Implementation
 * 		- Open "STM32F412GDISCO-Full-CM4_ARMCC-FreeRTOS-configuration\full.platform"
 * 		- Click on "Build Platform"
 *
 * 3- Compile a MicroEJ application against new platform
 *
 * 4- Specify right BSP display stack implementation value
 * 		- Set the following define (#define LCD_BPP) with the expected value
 * 			"16" for 16 bits per pixel
 * 			"4" for 4 bits per pixel
 * 			"2" for 2 bits per pixel
 * 			"1" for 1 bit per pixel
 *
 * 	5- Build, link and deploy your application as usual
 */
#define LCD_BPP 2

/*
 * Select the LCD orientation.
 * - LCD_ORIENTATION_PORTRAIT_1
 * - LCD_ORIENTATION_LANDSCAPE_1
 *
 * Modes LCD_ORIENTATION_PORTRAIT_2 and LCD_ORIENTATION_LANDSCAPE_2 are not available yet
 */
#define LCD_ORIENTATION_LANDSCAPE_1 0
#define LCD_ORIENTATION_PORTRAIT_1 1
#define LCD_ORIENTATION LCD_ORIENTATION_LANDSCAPE_1

#endif // _LLDISPLAY_CONFIGURATION
