/*
 * C
 *
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
 
 /* Includes ------------------------------------------------------------------*/

#include "LLLEDS_impl.h"
#include "stm32412g_discovery.h"

/* Private functions ----------------------------------------------------------*/

static Led_TypeDef get_led(int32_t ledID)
{
	switch(ledID)
	{
		default:
		case 0: return LED1;
		case 1: return LED2;
		case 2: return LED3;
		case 3: return LED4;
	}
}	

/* API ------------------------------------------------------------------------*/

int32_t LLLEDS_IMPL_getIntensity(int32_t ledID)
{
	// not available yet
	return LLLEDS_MIN_INTENSITY;
}

int32_t LLLEDS_IMPL_initialize(void)
{
	BSP_LED_Init(LED1);
	BSP_LED_Init(LED2);
	BSP_LED_Init(LED3);
	BSP_LED_Init(LED4);
	return 4;
}

void LLLEDS_IMPL_setIntensity(int32_t ledID, int32_t intensity)
{
	if (intensity == 0)
	{
		BSP_LED_Off(get_led(ledID));
	}
	else
	{
		BSP_LED_On(get_led(ledID));
	}
}
