/*
 * C
 *
 * Copyright 2016 IS2T. All rights reserved.
 * For demonstration purpose only.
 * IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/* Includes ------------------------------------------------------------------*/

#include <stdio.h>
#include "main.h"

/* Fields --------------------------------------------------------------------*/

static UART_HandleTypeDef UartHandle;
static int putchar_initialized = 0;

/* Private API ---------------------------------------------------------------*/

static void putchar_init(void)
{
	UartHandle.Instance        = USART2;
	UartHandle.Init.BaudRate   = 115200;
	UartHandle.Init.WordLength = UART_WORDLENGTH_8B;
	UartHandle.Init.StopBits   = UART_STOPBITS_1;
	UartHandle.Init.Parity     = UART_PARITY_NONE;
	UartHandle.Init.HwFlowCtl  = UART_HWCONTROL_NONE;
	UartHandle.Init.Mode       = UART_MODE_TX_RX;

	BSP_COM_Init(COM1, &UartHandle);
}

/* Public functions ----------------------------------------------------------*/

int fputc(int ch, FILE *f)
{
	if(!putchar_initialized)
	{
		putchar_init();
		putchar_initialized = 1; 
	}

	while (HAL_UART_Transmit(&UartHandle, (uint8_t *)&ch, 1, 100) == HAL_TIMEOUT)
	{
		putchar_init();
	}
	return ch;
}
