
/*
 *	Java
 *	
 *	Copyright 2016 IS2T. All rights reserved.
 *	IS2T PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */
package com.is2t.microej.fp;

import com.is2t.microej.frontpanel.input.generator.EventGenerator;
import com.is2t.microej.frontpanel.input.listener.JoystickListener;

public class JoystickListenerImpl implements JoystickListener {

	@Override
	public void pressDown(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonPressedEvent("JOYSTICK", getButtonDownID());
		} else {
			EventGenerator.sendCommandEvent("COMMANDS", getButtonDownCommand());
		}
	}

	@Override
	public void pressEnter(int joystickId) {
		// does not work on Emb side
		//		if (!Options.SEND_COMMANDS) {
		//			EventGenerator.sendButtonPressedEvent("JOYSTICK", getButtonEnterID());
		//		} else {
		//			EventGenerator.sendCommandEvent("COMMANDS", getButtonEnterCommand());
		//		}
	}

	@Override
	public void pressLeft(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonPressedEvent("JOYSTICK", getButtonLeftID());
		} else {
			EventGenerator.sendCommandEvent("COMMANDS", getButtonLeftCommand());
		}
	}

	@Override
	public void pressRight(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonPressedEvent("JOYSTICK", getButtonRightID());
		} else {
			EventGenerator.sendCommandEvent("COMMANDS", getButtonRightCommand());
		}
	}

	@Override
	public void pressUp(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonPressedEvent("JOYSTICK", getButtonUpID());
		} else {
			EventGenerator.sendCommandEvent("COMMANDS", getButtonUpCommand());
		}
	}

	@Override
	public void releaseDown(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonReleasedEvent("JOYSTICK", getButtonDownID());
		}
	}

	@Override
	public void releaseEnter(int joystickId) {
		// does not work on Emb side
		//		if (!Options.SEND_COMMANDS) {
		//			EventGenerator.sendButtonReleasedEvent("JOYSTICK", getButtonEnterID());
		//		}
	}

	@Override
	public void releaseLeft(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonReleasedEvent("JOYSTICK", getButtonLeftID());
		}
	}

	@Override
	public void releaseRight(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonReleasedEvent("JOYSTICK", getButtonRightID());
		}
	}

	@Override
	public void releaseUp(int joystickId) {
		if (!Options.SEND_COMMANDS) {
			EventGenerator.sendButtonReleasedEvent("JOYSTICK", getButtonUpID());
		}
	}

	@Override
	public void repeatDown(int joystickId) {
		// no repeat event
	}

	@Override
	public void repeatEnter(int joystickId) {
		// no repeat event
	}

	@Override
	public void repeatLeft(int joystickId) {
		// no repeat event
	}

	@Override
	public void repeatRight(int joystickId) {
		// no repeat event
	}

	@Override
	public void repeatUp(int joystickId) {
		// no repeat event
	}

	public int getButtonUpID() {
		// same ID as EmbJPF (see joystick.c)
		return 0;
	}

	public int getButtonDownID() {
		// same ID as EmbJPF (see joystick.c)
		return 1;
	}

	public int getButtonLeftID() {
		// same ID as EmbJPF (see joystick.c)
		return 2;
	}

	public int getButtonRightID() {
		// same ID as EmbJPF (see joystick.c)
		return 3;
	}

	public int getButtonEnterID() {
		// same ID as EmbJPF (see joystick.c)
		return 4;
	}

	public int getButtonUpCommand() {
		// same command as EmbJPF (see buttons_listener.c)
		return EventGenerator.UP;
	}

	public int getButtonDownCommand() {
		// same command as EmbJPF (see buttons_listener.c)
		return EventGenerator.DOWN;
	}

	public int getButtonLeftCommand() {
		// same command as EmbJPF (see buttons_listener.c)
		return EventGenerator.LEFT;
	}

	public int getButtonRightCommand() {
		// same command as EmbJPF (see buttons_listener.c)
		return EventGenerator.RIGHT;
	}

	public int getButtonEnterCommand() {
		// same command as EmbJPF (see buttons_listener.c)
		return EventGenerator.SELECT;
	}

}
